public class worldFunc{
    static vectorFunc v = new vectorFunc();
    static atomFunc a = new atomFunc();
    
    public static world resetForce(world olWorld)    // reset force accumulator
    {
        world nuWorld = new world(olWorld);
        for (int i=0;i<olWorld.atomQty;i++)
        {
            nuWorld.append(a.zeroforce(olWorld.atomLst[i]));
        }
        return nuWorld;
    }
    
    //martin modif   now completly functional
    //in a world were A B and C interact, A move in a world were B and C havent moved
    //B move in a world were A moved but not C, then C move in a world were A and B move
    //i changed that. Now A move in a world were B and C havent move, no change.
    //B move in a world wera A and C havent moved, then C move in a world were B and A havent move
    //keep a save of the world before transformation, then transform form that data.
    
    public static world interAtomCollisionResponse(world olWorld)
    {
        world nuWorld = new world(olWorld);
        atom nuAtom;
        for (int i=0;i<olWorld.atomQty;i++)
        {
            nuAtom = new atom(olWorld.atomLst[i]);
            
            boolean istate = a.getrest(nuAtom);
              
                for (int j=0; j<olWorld.atomQty; j++)
                {
                    if (i!=j)
                    {
                        boolean jstate = a.getrest(olWorld.atomLst[j]);
                        
                        if ((istate == true && jstate == false) || (istate == false && jstate == false))
                        {
                            vector link = v.sub(a.getpos(nuAtom), a.getpos(olWorld.atomLst[j]));    // get direction vector
                            float distCentersSQ = v.magSQ(link);                                    // get SQ distance, 
                            float restlenght = a.sizes(olWorld.atomLst[i], olWorld.atomLst[j]);     // get collision threshold

                            if (distCentersSQ == 0.0f)                                              // check if position overlap
                            {
                                //System.out.println("centers distance: "+ distCentersSQ +" , restlenght:" + restlenght);    // <---- BROKEN, WHY????
                                nuAtom = a.addforce(nuAtom, a.separate(nuAtom));
                                nuAtom = a.unrest(nuAtom);
                            }
                            else if (distCentersSQ < restlenght*restlenght)                         // check if collide
                            {
                                //System.out.println("distance from centers: "+ distCentersSQ + " , rest:" + restlenght);    // <---- BROKEN, WHY????
                                nuAtom = a.addforce(nuAtom, a.repulse(nuAtom, olWorld.atomLst[j], restlenght, distCentersSQ));
                                nuAtom = a.unrest(nuAtom);
                            }
                        } 
                    }
                }
            nuWorld.append(nuAtom);
        }
        return nuWorld;
    }
    
    public static world boxCollisionDetectionResponse(world olWorld)
    {
        world nuWorld = new world(olWorld);
        atom nuAtom;
        for (int i=0;i<olWorld.atomQty;i++)
        {
            nuAtom = olWorld.atomLst[i];
            nuAtom = a.hardcollision(nuAtom, olWorld.boxSize, olWorld.boxPos, olWorld.surfBounce, olWorld.surfFriction);
            nuAtom = a.terminalvelocity(nuAtom);
            nuAtom = a.velocitydrag(nuAtom);
            nuAtom = a.restingTest(nuAtom);
                        
            nuWorld.append(nuAtom);
        }
        return nuWorld;
    }
    
    public static world environmentalForce(world olWorld)
    {
        world nuWorld = new world(olWorld);
        atom nuAtom;
        for (int i=0;i<olWorld.atomQty;i++)
        { 
            nuAtom = olWorld.atomLst[i];
            nuAtom = a.gravity(nuAtom, olWorld.gravity);
            nuAtom = a.terminalforces(nuAtom);
            //nuAtom = a.restingTest(nuAtom);  
            //wind
            //etc
            nuWorld.append(nuAtom);
        }
        return nuWorld;
    }
    
    public static world integrate(world olWorld, float deltaT)
    {
        world nuWorld = new world(olWorld);
        for (int i=0;i<olWorld.atomQty;i++)
        {
            if (a.getrest(olWorld.atomLst[i]) == false)
            {
                nuWorld.append(a.integrate(olWorld.atomLst[i], deltaT));
            }
            else
            {
                nuWorld.append(olWorld.atomLst[i]);
            }
        }
        return nuWorld;
    }
    

};
